;;; -*- Mode: Lisp; Package: USER; Last modified: "2019/03/12 23:12:51" -*-
;;;
;;; This file is not part of xyzzy.
;;;
;;;   open-jungle.l --- Open a junk (memo) file to trial-and-error
;;;
;;;     Author: HIE Masahiro
;;;     URL: http://hie.s64.xrea.com/xyzzy/
#|

Tv

  "~/junk/N//"tH_ɁA"-b." + "w肵gq"ȃt@C
  ĊJ܂B*scratch* obt@̑ɁAU炩Ȃ玎s
  邽߂Ɏgp肵܂B*scratch* obt@ƔׁA̗_܂B

    EۑłB
    EK؂ȃ[hŕҏWłB

  open-jungle.l ́Arubikitch  open-junk-file.el eLg[ɈڐA
  ̂łB

      URL: https://github.com/rubikitch/open-junk-file

  IWiɒɂƎvč肩̂́A͂ȂȂ߁A
  O͕ςĂ܂܂B(--

    [ύX_]
     EȈՓIȃev[g}@\ǉ
     EȈՓIGrep@\ǉ
     EtbNϐǉ
     EۑꏊƏ̕ϐ𕪊
     EVOt@CŕۑꏊJ@\ǉ
     Exyzzyœ삷(͂)B

    [򉻓_]
     Eopen-junk-file ̈ȗ(FORMAT, FIND-FILE-FN)ύX
     EoO|[g@\͖
     EEmacsœ삵ȂB


CXg[

  1. open-jungle.l  site-lisp ɃRs[B

  2. KvɉCoCgRpCB

       M-x byte-compile-file

  3. .xyzzy  siteinit.l Ɉȉ̋LqǉB

      (require "open-jungle")

  4. xyzzy ċNCݒ𔽉fB
     siteinit.l ɋLqꍇ͍ă_vB


N@

    M-x open-jungle        : V JUNK file J

      sƁAL̂悤Ƀ~jobt@ɍ쐬 JUNK file ̊gq
      ͂߂܂B

        Junk Code (Enter extension): P:/dat/junk/2019-0303-152054.

      JUNK file JAƂ͂RɎs낵ĂB

    M-x open-jungle-grep   : JUNK file ̕ۑꏊ Grep
    M-x open-jungle-sfiler : VOt@CŕۑꏊJ


ݒ

    ;;; L[oChǉ
    (define-key ctl-x-map #\j 'open-jungle)
    (define-key ctl-x-map #\g 'open-jungle-grep)

    ;;; ۑꏊύX
    (setq *open-jungle-base-dir* "P:/home/junk/")

    ;;; "N//"tH_쐬Ȃ
    (setq *open-jungle-format* "%Y-%m%d-%H%M%S.")

    ;;; ʑŊJȂ
    (setq *open-jungle-find-file-function* #'find-file)

    ;;; ev[gǉ
    (setq *open-jungle-template-alist*
          '(("\\.txt$" . "-*- Mode: Text; last modified: \"\"; -*-\n")
            ("\\.eml$" . "Subject: ")))


܂

    EM-x open-jungle-sfiler At@Cw肵 W ƁA܂܂ȋ
      łB(xyzzy W@\)

    EȂt@C͂ɍ폜̂ŁAȊ֐`ĂB

        ;;; obt@VisitĂt@C폜
        (defun delete-file-and-kill-buffer ()
          "Kill the current buffer and deletes the file it is visiting."
          (interactive)
          (let ((filename (get-buffer-file-name)))
            (when (and filename
                       (file-exist-p filename)
                       (y-or-n-p (concat filename " 폜͂́H")))
              (save-buffer)
              (delete-file filename)
              (message "Deleted file ~A" filename)))
          (delete-buffer (selected-buffer)))
        (define-key ctl-x-map #\Delete 'delete-file-and-kill-buffer)

    EM-x open-jungle-grep āA͂̂܂ Enter ƁAVOt@C
      JBL[oCh炵̂ŁB


XV

  [Version 1.01] 2019-03-12 ()
  EJUNK file J֐̐ݒύXB(*open-jungle-find-file-function*)
  E*after-open-jungle-hook* ɈƂăt@Cn悤ɂB

  [Version 1.00] 2019-03-06 ()
  Eō쐬B


CZX

  open-jungle.l ̔zz GNU General Public License Version 2
  ̏ŁAEς̂zz邱Ƃł܂B

open-jungle.l --- Open a junk (memo) file to trial-and-error

Copyright (C) 2019 HIE Masahiro

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

|#

(provide "open-jungle")

(defvar *open-jungle-base-dir* "~/junk/"
  "open-jungle: JUNK file ̕ۑꏊ")

(defvar *open-jungle-format* "%Y/%m/%d-%H%M%S."
  "open-jungle: JUNK file ̏")

(defvar *open-jungle-hook* nil
  "open-jungle: JUNK file JɎstbNϐ")

(defvar *after-open-jungle-hook* nil
  "open-jungle: open-jungle ̍ŌɎstbNϐ")

(defvar *open-jungle-template-alist* nil
  "open-jungle: JUNK file 쐬}")

(defvar *open-jungle-find-file-function* #'find-file-other-window
  "open-jungle: JUNK file J֐")

(defun find-file-hook--open-jungle ()
  "Run `open-jungle-hook' when the file is a JUNK file."
  (when (eq 0 (string-match
	       (concat (directory-namestring *open-jungle-base-dir*) ".*")
	       (directory-namestring (get-buffer-file-name))))
    (run-hooks '*open-jungle-hook*)))

(add-hook '*find-file-hooks* 'find-file-hook--open-jungle)

(defun open-jungle (file)
  "open-jungle: t@CݎhVt@CJ܂B"
  (interactive "FJunk Code (Enter extension): "
    :default0 (format-date-string
	       (concat *open-jungle-base-dir*
		       *open-jungle-format*)))
  (let ((dir (directory-namestring file)))
    (create-directory dir :if-exists :skip)
    (funcall *open-jungle-find-file-function* file)
    (dolist (ext *open-jungle-template-alist*)
      (when (string-matchp (car ext) file)
	(insert (cdr ext))
	(return))))
  (run-hook-with-args '*after-open-jungle-hook* file))

(defun open-jungle-grep ()
  "open-jungle: JUNK file ̕ۑꏊ Grep ܂B
wȂŎsƁAVOt@CŊJ܂B"
  (interactive)
  (let ((pattern (read-string "Grep Junk File: ")))
    (if (string= pattern "")
	(open-jungle-sfiler)
      (let ((file (read-string "File: " :default "*.*"))
	    (dir *open-jungle-base-dir*))
	(unless (string= file "")
	  (add-history pattern '*minibuffer-search-string-history*)
	  (add-history dir 'ed::*grep-directory-history*)
	  (ed::scan-files pattern file dir))))))

(defun open-jungle-sfiler ()
  "open-jungle: JUNK file ̕ۑꏊVOt@CŊJ܂B"
  (interactive)
  (toggle-ime nil)
  (multiple-value-bind (files result)
      (filer *open-jungle-base-dir* t "Open Junk File" nil)
    (when result
      (dolist (f files t)
	(unless (file-directory-p f)
	  (find-file f))))))


;;; open-jungle.l ends here
